.plugin asm83p  ; make sure we make a TI-83+ program with Assembly
; Studio 8X 4.0. The reason I didn't use an #include is because we
; want this to be a standalone source. Also, having a header for only
; 2 needed equates is stupid

plotsscreen equ 8E29h ; address in RAM for the graph screen
_copygbuf   equ 4B9Ch ; address pointing to routine for copying graph to screen

.org $9D95       ; point to where programs are loaded in RAM

 ld (hl),$FF     ; (address value) = 255
 ; load the address the 16-bit register, hl, points to with 255 (aka $FF)
LoopDown:        ; this loop decreases until the screen is blank
 call FillScreen ; executes subroutine to fill the screen with the value in hl's address
 dec (hl)        ; decrease the value in hl's address
 ld a,(hl)       ; save it to the accumulator
 cp 0            ; compare the accumulator to zero; a=0?
 jr nz,LoopDown  ; if it's not zero, continue looping

; This routine is called from the loop to fill the screen with a
; value. the graphical effect seems to shutter from black to white
; notice there's no "ret" after the loops exiting statement that
; means when a=0 it'll run this screen filler for the last time,
; outside the loop thereby clearing the screen (filling graphics
; screen with zeros) and finally exiting
FillScreen:
 ld a,(hl)       ; load the accumulator with the value from (hl)
 push af         ; save 16-bit pair af to the stack
 ld de,plotsscreen+1 ; load 16-bit register pair de with graph screen address+1
 ld hl,plotsscreen  ; load 16-bit register pair hl with graph screen address
 ld bc, 767      ; set the 16-bit reg pair bc with 767 (byte size of screen - 1)
 pop af          ; restore 16-bit pair af from the stack
 ld (hl),a       ; save to the address hl points to
 ldir            ; copy byte, increase de and hl, decrease bc, repeat until bc=0
 rst 28h         ; sets OS for making a ROM call.
 .dw _copygbuf   ; values to define the address where the graph screen buffer copying
                 ; routine is located - so that everyone can see the picture
 ret             ; return from the routine, and finally exit after the last loop

.end ; the end of the program. code stops here